#
# spec file for package BNFC
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name BNFC
%bcond_with tests
Name:           %{pkg_name}
Version:        2.8.1
Release:        2.64
Summary:        A compiler front-end generator
License:        GPL-2.0+
Group:          Development/Languages/Other
Url:            https://hackage.haskell.org/package/%{name}
Source0:        https://hackage.haskell.org/package/%{name}-%{version}/%{name}-%{version}.tar.gz
BuildRequires:  alex
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-array-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-pretty-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  happy
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if %{with tests}
BuildRequires:  ghc-HUnit-devel
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-doctest-devel
BuildRequires:  ghc-hspec-devel
BuildRequires:  ghc-temporary-devel
%endif

%description
The BNF Converter is a compiler construction tool generating a compiler
front-end from a Labelled BNF grammar. It was originally written to generate
Haskell, but starting from Version 2.0, it can also be used for generating
Java, C++, and C.

Given a Labelled BNF grammar the tool produces: an abstract syntax as a
Haskell/C++/C module or Java directory, a case skeleton for the abstract syntax
in the same language, an Alex, JLex, or Flex lexer generator file, a Happy,
CUP, or Bison parser generator file, a pretty-printer as a Haskell/Java/C++/C
module, a Latex file containing a readable specification of the language.

%package -n ghc-%{name}
Summary:        Haskell %{name} library
Group:          System/Libraries

%description -n ghc-%{name}
This package provides the Haskell %{name} shared library.

%package -n ghc-%{name}-devel
Summary:        Haskell %{name} library development files
Group:          Development/Libraries/Other
Requires:       ghc-%{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description -n ghc-%{name}-devel
This package provides the Haskell %{name} library development files.

%prep
%setup -q

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post -n ghc-%{name}-devel
%ghc_pkg_recache

%postun -n ghc-%{name}-devel
%ghc_pkg_recache

%files
%defattr(-,root,root,-)
%doc LICENSE
%doc TODO changelog
%{_bindir}/bnfc

%files -n ghc-%{name} -f ghc-%{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files -n ghc-%{name}-devel -f ghc-%{name}-devel.files
%defattr(-,root,root,-)
%doc TODO changelog

%changelog
* Sun Jul 10 2016 psimons@suse.com
- Update to version 2.8.1 revision 0 with cabal2obs.
  This update obsoletes bnfc-ord-fix.patch.
* Sun Nov 29 2015 mimi.vx@gmail.com
- bnfc-ord-fix.patch "John J. Camilleri" <john@johnjcamilleri.com> fix build with
    ghc-7.10.2 and alex-3.1.5
* Wed May 27 2015 peter.trommler@ohm-hochschule.de
- update to 2.8
  * Builds with ghc 7.10.1
  * Add support for JFlex (java)
  * Add an option to generate files in an other directory
  * Add an experimental option that turns the AST into a parametrized functor (in Haskell only)
  * New pygment backend to generate syntax highlighters
* Wed Nov 26 2014 peter.trommler@ohm-hochschule.de
- update to 2.7.1
  * fix compilation with ghc 7.8
* Tue Jun 17 2014 peter.trommler@ohm-hochschule.de
- initial packaging (version 2.6.0.3)
